         subroutine MATVEC( xin,rout) 
         use my_data
         
         DOUBLE PRECISION alpha, beta, xin(ncoef),rout(ncoef)
         INTEGER i,jpers,jfirm

         ! Compute the matrix vector product rout <- A*xin 
         ! with A = (X D F)'(X D F) stored in parts in my_data
         ! X'X in xxin(ncov,ncov), but assumed identity from preconditioning
         ! X'D in xd(npers,ncov)
         ! X'F in xf(nfirm,ncov)
         ! D'F in df(ncells), person and firm indicies in dfp(ncells) and dff(ncells)
         ! D'D is identity from preconditioning dimension(npers,npers)
         ! F'F is identity from preconditioning dimension(nfirm,nfirm) 
         ! The vectors x and r have three parts:
         ! The covariate effects 1:ncov
         ! The person effects ncov+1:ncov+npers
         ! The firm effects ncov+npers+1:ncoef (ncoef=ncov+npers+nfirm-1)
         !
         ! First the covariate effects
         rout = xin        ! xx, dd and ff are identity
         alpha = 1.0
         beta = 1.0
!        call DEGEMV(TRANS, M, N, ALPHA, A, LDA, X, INCX, BETA, Y, INCY)
         call dgemv('T', npers, ncov, alpha, xd, npers, xin(ncov+1), 1, &
              beta, rout(1), 1) 
         call dgemv('T', nfirm-1, ncov, alpha, xf, nfirm, xin(ncov+npers+1), 1, &
              beta, rout(1), 1) 
         ! Then the person effects
         call dgemv('N', npers, ncov, alpha, xd, npers, xin(1), 1, &
              beta, rout(ncov+1), 1) 
         ! Then the firm effects
         call dgemv('N', nfirm-1, ncov, alpha, xf, nfirm, xin(1), 1, &
              beta, rout(ncov+npers+1), 1)
         ! And contributions from D'F and F'D to person and firm effects
         do i = 1,ncells
            jpers = dfp(i)+ncov
            jfirm = dff(i)+ncov+npers
            if (jfirm .le. ncoef) then
               rout(jpers) = rout(jpers) + xin(jfirm)*df(i)
               rout(jfirm) = rout(jfirm) + xin(jpers)*df(i)
            end if
         end do        
         return
         end


