      program testcg
      use MY_DATA

      INTEGER i,j,jp,jf,maxit,icell,info, imem,idmem,err,LRECL
      REAL*8 alpha,beta,resid
      CHARACTER*1 transa, transb
      read(5,*) n,ncells,npers,nfirm,ncov
      write(6,10) n,ncells,npers,nfirm,ncov
10    format("Number of observations   ",I10,/, &
             "Number of distinct cells ",I10,/, &
             "Number of persons        ",I10,/, &
             "Number of firms          ",I10,/, &
             "Number of covariates     ",I10,//)
      LRECL = 2*ncov + 4                    ! recordsize in 32 bit words
      ncoef = ncov + npers + nfirm - 1
      ALLOCATE(pers(n), firm(n), dfp(ncells),dff(ncells),stat = err)
      imem = 4*(n+n + 2*ncells)/(1024*1024)
      if (err .eq. 0) write(6,20) imem
20    format("Allocated integer variables ", I10, " megabytes")
      allocate(covin(ncov),y(n),d(npers),f(nfirm), &
           df(ncells),xx(ncov,ncov), rq(ncov,ncov),xd(npers,ncov),xf(nfirm,ncov), &
           theta(ncoef),b(ncoef),r(ncoef),w(ncoef),p(ncoef),q(ncoef),stat = err)
      idmem = 8*(ncov + n + npers + nfirm + ncells + 2*ncov*ncov + &
              npers*ncov + nfirm*ncov + 6*ncoef)/(1024*1024)
      if (err .eq. 0) write(6,30) idmem
30    format("Allocated double variables  ", I10, " megabytes")
       idmem = idmem + imem
       write(6,35) idmem
35     format("Total memory allocated      ",I10, " megabytes")
      write(6,40)
 40   format("Starting to read and preprocess data")
      alpha = 1.0D0
      beta= 0.0D0
      icell = 0
      y = 0.0D0
      b = 0.0D0
      d = 0.0D0
      f = 0.0D0
      df = 0.0D0
      xd = 0.0D0
      xf = 0.0D0
      xx = 0.0D0
      open(unit=8,form="UNFORMATTED",recl=LRECL,recordtype="FIXED",status="OLD")
      do i = 1,n
! ASSUMPTION  -  data is sorted by person, then firm
         read(8) y(i),covin,pers(i),firm(i)
         if (i .eq.1 .or. pers(i) .ne. pers(i-1) .or. &
         (firm(i) .ne. firm(i-1) .and. pers(i) .eq. pers(i-1))) &
            icell = icell + 1
         jp = pers(i)
         d(jp) = d(jp) + 1.0D0
         dfp(icell) = jp
         jf = firm(i)
         f(jf) = f(jf) + 1.0D0
         dff(icell) = jf
         df(icell) = df(icell) + 1.0D0
         do j = 1, ncov
            xd(jp,j) = xd(jp,j) + covin(j)
            xf(jf,j) = xf(jf,j) + covin(j)
            do k = 1, ncov
               xx(j,k) = xx(j,k) + covin(j)*covin(k)
            end do   
         end do
         b(1:ncov) = b(1:ncov) +y(i)*covin           ! accumulate X'y
         b(jp+ncov) = b(jp+ncov) + y(i)
         if(jf .ne. nfirm) then
            b(jf+ncov+npers) =  b(jf+ncov+npers) + y(i)
         end if
      end do

      if (icell .ne. ncells) then
         write(6,42) icell,ncells
42       format(" Error - number of cells read ",I9, " not equal number specified ",I9)
      end if
! Comment out next line if coefficients are read
       theta = 0.0
!     Read saved coefficients from previous run
!
!       do i = 1, ncoef
!          read(11,*) j,theta(i)
!       end do

!
!     Preconditioning steps - use diag of D'D and F'F and a transform
!       of X'X (cov'cov) so that X'X = I
!     Transform covariates using Cholesky decomposition in several steps:
!     1. Compute qtq = cov'cov (same as X'X)
!     2. Compute Cholesky decomposition of xx = u'u (stored in xx)
!     3  Transform cov with inverse of u cov <- cov*inverse(u) so cov'cov = I
!     4. Save R (upper triangular part) to restore covariate effects
!    
! 
!     3. Replace cov with Q

      write(6,12)
 12   format(" Finished reading and preprocessing - starting preconditioning")

!     2. Compute Cholesky decomposition of xx = u'u (stored in xx)     
      call dpotrf('U',ncov,xx,ncov,info)
      if (info .eq. 0) write(6,15)
 15   format(" Finished Cholesky part 1 DPOTRF")
      if (info .ne. 0) then
         write(6,16) info
 16      format(" Error in DPOTRF - info = ",I5)
         stop
      end if
!    2. Save R (upper triangular part) to restore covariate effects
      rq = xx
!      write(12,14) xx
!     3. The effect of transforming cov with inverse of u cov <- cov*inverse(u) so cov'cov = I
!         is to transform xd and xf  xd <- xd*inverse(u) xf <- xf*inverse(u)
!      call dtrsm('R','U','N','N',n,ncov,alpha,rq,ncov,cov(1,2),n)
      call dtrsm('R','U','N','N',npers,ncov,alpha,rq,ncov,xd,npers)
      call dtrsm('R','U','N','N',nfirm,ncov,alpha,rq,ncov,xf,nfirm)
!     Use diag(D'D) and diag(F'F) in preconditioning
      d = 1/sqrt(d)
      f = 1/sqrt(f)
      do i = 1,ncov
         xd(:,i) = xd(:,i)*d
         xf(:,i) = xf(:,i)*f
      end do
      do i = 1,ncells
         df(i) = df(i)*d(dfp(i))*f(dff(i))
      end do
!     b <- (X D F)'y - already done just need to condition consistently
      call dtrsm('R','U','N','N',1,ncov,alpha,rq,ncov,b,1)
      b(ncov+1:ncov+npers) =  b(ncov+1:ncov+npers)*d
      b(ncov+npers+1:ncoef) = b(ncov+npers+1:ncoef)*f(1:nfirm-1)
!      call xtprod(pers, npers, firm, nfirm,cov(1,2),ncov,y,n,b, &
!       ncoef,f,d)
      resid = 1.0E-7
      maxit = 1000
!       Transform theta to new scale
!     CALL DTRMV(UPLO, TRANS, DIAG, N, A, LDA, X, INCX)
      call dtrmv('U','N','N', ncov, rq, ncov, theta, 1)
       do jp = 1,npers
          j = ncov + jp
          theta(j) = theta(j)/d(jp)
       end do  
       do jf = 1,nfirm-1
          j = ncov + npers + jf
          theta(j) = theta(j)/f(jf)
       end do
       write(6,17)
17     format("Beginning conjugate gradient iterations")
      call modcg(ncoef,b,theta,r,w,p,q,maxit,resid)
!     Transform theta back to original scale
       call dtrsv('U','N','N', ncov, rq, ncov,theta(1),1)
       do jp = 1,npers
          j = ncov + jp
          theta(j) = theta(j)*d(jp)
       end do  
       do jf = 1,nfirm-1
          j = ncov + npers + jf
          theta(j) = theta(j)*f(jf)
       end do  
      do i = 1,ncov
         j = i
         write(10,60) j,theta(i)
      end do
      do i = ncov+1, ncov+npers
         j = i-ncov
         write(10,60) j,theta(i)
      end do
      do i = ncov+npers+1,ncoef
        j = i - ncov - npers
        write(10,60) j,theta(i)
      end do
 60   format(I10,1x,e15.7)
      stop
      end





